#pragma once
#include "CJsonObject.h"
#include "CJsonArray.h"
#include "CVariant.h"
#include "CString.h"

namespace LSFramework
{
  enum class EJsonDataType
  {
    Unknown = 0,
    Value,
    Object,
    Array
  };

  class CJsonNode
  {

  private:
    union UJsonDataType
    {
      void* m_pVoid;
      CVariant* m_ovValue;
      CJsonObject* m_poJsonObject;
      CJsonArray* m_poJsonArray;
    };
    UJsonDataType m_uData;
    EJsonDataType m_eType = EJsonDataType::Unknown; //!< Enum of current stored Object type.
    CString m_sName;                                //!< Name of this Object
  };

}
