#pragma once
#include "LSFramework.Exports.h"
#include "LSMacros.h"
#include "CListItem.h"

namespace Framework
{
  template <class T>

  class LSFRAMEWORK_API CList
  {
  public:
    //-----------------------------------------------------------------------------------------------------------------------------
    CList()
    {
    }

    //-----------------------------------------------------------------------------------------------------------------------------
    ~CList()
    {
      DELETE_ARRAY(m_pFirst)
      DELETE_ARRAY(m_pLast)
    }

    //-----------------------------------------------------------------------------------------------------------------------------
    CListItem<T>* Append(T tObj)
    {
      CListItem<T>* pNewLast;
      if (!m_pFirst)
      {
        m_pFirst = new CListItem<T>(tObj);
        m_pLast = new CListItem<T>(tObj);
        m_pFirst->pNext = m_pLast;
        pNewLast = m_pFirst;
      }
      else
      {
        pNewLast = new CListItem<T>(tObj);
        if (m_pLast->pBefore)
        {
          CListItem<T>* pCurrentLast = m_pLast;
          pCurrentLast->pNext = pNewLast;
          pNewLast->pBefore = pCurrentLast;
        }
        else
        {
          m_pFirst->pNext = pNewLast;
          pNewLast->pBefore = m_pFirst;
        }
        m_pLast = pNewLast;
      }
      m_zSize++;
      return pNewLast;
    }

    //-----------------------------------------------------------------------------------------------------------------------------
    CListItem<T>* Remove(T tObj)
    {
      if (m_zSize == 0) return nullptr;

      CListItem<T>* pItemToRemove = m_pFirst;

      while (pItemToRemove->tValue != tObj)
      {
        pItemToRemove = pItemToRemove->pNext;
      }

      CListItem<T>* pRet = nullptr;

      if (m_zSize <= 1)
      {
        m_pFirst = nullptr;
        m_pLast = nullptr;
      }
      else if (pItemToRemove == m_pFirst)
      {
        CListItem<T>* pNewFirst = pItemToRemove->pNext;
        pNewFirst->pBefore = nullptr;
        m_pFirst = pNewFirst;
        pRet = pNewFirst;
      }
      else if (pItemToRemove == m_pLast)
      {
        CListItem<T>* pNewLast = pItemToRemove->pBefore;
        pNewLast->pNext = nullptr;
        m_pLast = pNewLast;
        pRet = pNewLast;
      }
      else
      {
        CListItem<T>* pBefore = pItemToRemove->pBefore;
        CListItem<T>* pNext = pItemToRemove->pNext;
        pBefore->pNext = pNext;
        pNext->pBefore = pBefore;
        pRet = pNext;
      }

      DELETE_POINTER(pItemToRemove);
      m_zSize--;
      return pRet;
    }

    //-----------------------------------------------------------------------------------------------------------------------------
    T* RemoveAt(size_t zPos)
    {

    }

  private:
    CListItem<T>* m_pFirst = nullptr;
    CListItem<T>* m_pLast = nullptr;
    size_t m_zSize = 0;
  };
}